package holeg.ui.view.dialog;

import holeg.preferences.ImagePreference;
import holeg.ui.view.image.Import;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * AboutUs Pop Up Window.
 *
 * @author Gruppe14
 */
public class AboutUsPopUp extends JFrame {

  /**
   * Constructor
   */
  public AboutUsPopUp(JFrame parentFrame) {
    super("About Us");

    // Set fonts
    Font fontTitle = new Font("Titel", Font.ITALIC, 35);
    JLabel titel = new JLabel("HOLEG Simulator");
    titel.setFont(fontTitle);
    titel.setBounds(150, 30, 100, 20);
    Font headerFont = new Font("Header", Font.ITALIC, 20);
    JLabel h1 = new JLabel("Project Management & Architect");
    h1.setFont(headerFont);
    JLabel h2 = new JLabel("Software Developers");
    h2.setFont(headerFont);
    JLabel h3 = new JLabel("Documentation");
    h3.setFont(headerFont);
    JLabel h4 = new JLabel("Additional Collaborators");
    h4.setFont(headerFont);

    // Set labels
    titel.setHorizontalAlignment(JLabel.CENTER);

    // Set layout
    JPanel contentPanel = new JPanel();
    contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.Y_AXIS));
    JPanel contentPanel2 = new JPanel();
    contentPanel2.setLayout(new BoxLayout(contentPanel2, BoxLayout.Y_AXIS));
    JPanel contentPanel3 = new JPanel();
    contentPanel3.setLayout(new BoxLayout(contentPanel3, BoxLayout.Y_AXIS));

    this.setIconImage(Import.loadImage(ImagePreference.Logo, 30, 30));
    setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    setBounds(100, 100, 500, 800);
    setLocationRelativeTo(parentFrame);

    contentPanel.add(Box.createRigidArea(new Dimension(0, 15)));
    contentPanel.add(titel);
    contentPanel.add(Box.createRigidArea(new Dimension(0, 15)));
    JLabel description = new JLabel(
        "A discrete-time simulator for modeling Smart Grids that follow a Holon-based model.");
    contentPanel.add(description);
    contentPanel.add(Box.createRigidArea(new Dimension(0, 60)));
    getContentPane().add(contentPanel, BorderLayout.NORTH);

    contentPanel2.add(h1);
    JLabel namesManagement = new JLabel("C. Garcia Cordero");
    contentPanel2.add(namesManagement);
    contentPanel2.add(Box.createRigidArea(new Dimension(0, 50)));
    contentPanel2.add(h2);
    JLabel namesDevelopersUntilV2 = new JLabel(
        "K. Trometer, D. Rieder, T. Zheng, J. Widhalm, E. Palza, I. Dix");
    contentPanel2.add(namesDevelopersUntilV2);
    JLabel namesDevelopersV2_1 = new JLabel(
        "A.T. Meyer-Berg, A. Schneider, T. Troppmann and L. Tietze");
    contentPanel2.add(namesDevelopersV2_1);
    contentPanel2.add(Box.createRigidArea(new Dimension(0, 50)));
    contentPanel2.add(h3);
    JLabel namesDocumentation = new JLabel("E. Palza, C. Garcia Cordero");
    contentPanel2.add(namesDocumentation);
    contentPanel2.add(Box.createRigidArea(new Dimension(0, 50)));
    contentPanel2.add(h4);
    JLabel namesCollaborators = new JLabel("R. Egert and F. Volk");
    contentPanel2.add(namesCollaborators);
    contentPanel2.add(Box.createRigidArea(new Dimension(0, 50)));
    JLabel credits = new JLabel();
    contentPanel2.add(credits);
    getContentPane().add(contentPanel2, BorderLayout.CENTER);

    contentPanel3.add(Box.createRigidArea(new Dimension(0, 50)));
    //contentPanel3.add(namesDevelopers);
    getContentPane().add(contentPanel3, BorderLayout.SOUTH);
    this.setVisible(true);
  }
}